<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::settings::Setting&lt; ValueT &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1settings.html">settings</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">Setting</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1settings_1_1_setting-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::settings::Setting&lt; ValueT &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_setting_8h_source.html">Setting.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::settings::Setting&lt; ValueT &gt;:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1settings_1_1_setting__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1settings_1_1_setting_3_01_value_t_01_4_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1settings_1_1_setting_3_01_value_t_01_4_inherit__map" id="alexa_client_s_d_k_1_1settings_1_1_setting_3_01_value_t_01_4_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html" title="alexaClientSDK::settings\l::SettingInterface\&lt; ValueT \&gt;" alt="" coords="5,5,191,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::settings::Setting&lt; ValueT &gt;:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1settings_1_1_setting__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1settings_1_1_setting_3_01_value_t_01_4_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1settings_1_1_setting_3_01_value_t_01_4_coll__map" id="alexa_client_s_d_k_1_1settings_1_1_setting_3_01_value_t_01_4_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html" title="alexaClientSDK::settings\l::SettingInterface\&lt; ValueT \&gt;" alt="" coords="5,5,191,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a61935305c6fe45ec6b9f7ec29a2a8842"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> = ValueT</td></tr>
<tr class="memdesc:a61935305c6fe45ec6b9f7ec29a2a8842"><td class="mdescLeft">&#160;</td><td class="mdescRight">Define an alias for setting value type.  <a href="#a61935305c6fe45ec6b9f7ec29a2a8842">More...</a><br /></td></tr>
<tr class="separator:a61935305c6fe45ec6b9f7ec29a2a8842"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">alexaClientSDK::settings::SettingInterface&lt; ValueT &gt;</a></td></tr>
<tr class="memitem:ad7cd5426acdf5103db1e03dfd4a51ab3 inherit pub_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a> = ValueT</td></tr>
<tr class="memdesc:ad7cd5426acdf5103db1e03dfd4a51ab3 inherit pub_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Define the setting value type.  <a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">More...</a><br /></td></tr>
<tr class="separator:ad7cd5426acdf5103db1e03dfd4a51ab3 inherit pub_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3157e9ad281e270e4fafa721977645c5 inherit pub_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a3157e9ad281e270e4fafa721977645c5">ObserverType</a> = <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_observer_interface.html">SettingObserverInterface</a>&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">SettingInterface</a>&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a> &gt; &gt;</td></tr>
<tr class="memdesc:a3157e9ad281e270e4fafa721977645c5 inherit pub_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Define the observer type for this setting.  <a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a3157e9ad281e270e4fafa721977645c5">More...</a><br /></td></tr>
<tr class="separator:a3157e9ad281e270e4fafa721977645c5 inherit pub_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa5384b7a6caf7330b59f552c14287610"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#aa5384b7a6caf7330b59f552c14287610">setAvsChange</a> (const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;value)</td></tr>
<tr class="separator:aa5384b7a6caf7330b59f552c14287610"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">SettingInterface methods.</div></td></tr>
<tr class="memitem:afbc4078956e082308e2137df57dd349d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5">SetSettingResult</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#afbc4078956e082308e2137df57dd349d">setLocalChange</a> (const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;value) override</td></tr>
<tr class="separator:afbc4078956e082308e2137df57dd349d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">alexaClientSDK::settings::SettingInterface&lt; ValueT &gt;</a></td></tr>
<tr class="memitem:a12421c86bb8fab5218c5d4dbdd4fdf20 inherit pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a12421c86bb8fab5218c5d4dbdd4fdf20">get</a> () const</td></tr>
<tr class="separator:a12421c86bb8fab5218c5d4dbdd4fdf20 inherit pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aafcf4c4bdb2afe20a9b26648484b5f70 inherit pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aafcf4c4bdb2afe20a9b26648484b5f70">addObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a3157e9ad281e270e4fafa721977645c5">ObserverType</a> &gt; observer)</td></tr>
<tr class="separator:aafcf4c4bdb2afe20a9b26648484b5f70 inherit pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aea3aa5f2529adbbd55bf6f578a5c6d25 inherit pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aea3aa5f2529adbbd55bf6f578a5c6d25">removeObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a3157e9ad281e270e4fafa721977645c5">ObserverType</a> &gt; &amp;observer)</td></tr>
<tr class="separator:aea3aa5f2529adbbd55bf6f578a5c6d25 inherit pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a7f6cdc887544b8a1e0e32e209d73cd inherit pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a1a7f6cdc887544b8a1e0e32e209d73cd">~SettingInterface</a> ()=default</td></tr>
<tr class="separator:a1a7f6cdc887544b8a1e0e32e209d73cd inherit pub_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ae6762ec41c5f95eb9d70de9f77c7bbfd"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">Setting</a>&lt; ValueT &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#ae6762ec41c5f95eb9d70de9f77c7bbfd">create</a> (const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;defaultValue, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_protocol_interface.html">SettingProtocolInterface</a> &gt; settingProtocol, std::function&lt; bool(const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;)&gt; applyValueFn=std::function&lt; bool(const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;)&gt;())</td></tr>
<tr class="separator:ae6762ec41c5f95eb9d70de9f77c7bbfd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td colspan="2" onclick="javascript:toggleInherit('pro_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface')"><img src="closed.png" alt="-"/>&#160;Protected Types inherited from <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">alexaClientSDK::settings::SettingInterface&lt; ValueT &gt;</a></td></tr>
<tr class="memitem:ad2e51acb29ec4de6cfca094e5e871a1c inherit pro_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad2e51acb29ec4de6cfca094e5e871a1c">GuardedValue</a> = <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_guarded_value.html">avsCommon::utils::GuardedValue</a>&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a> &gt;</td></tr>
<tr class="memdesc:ad2e51acb29ec4de6cfca094e5e871a1c inherit pro_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Alias for GuardedValue with the templated value <code>ValueType</code>.  <a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad2e51acb29ec4de6cfca094e5e871a1c">More...</a><br /></td></tr>
<tr class="separator:ad2e51acb29ec4de6cfca094e5e871a1c inherit pro_types_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">alexaClientSDK::settings::SettingInterface&lt; ValueT &gt;</a></td></tr>
<tr class="memitem:a98a48c39bc508f7a405283273acd84a8 inherit pro_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a98a48c39bc508f7a405283273acd84a8">SettingInterface</a> (const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a> &amp;value)</td></tr>
<tr class="separator:a98a48c39bc508f7a405283273acd84a8 inherit pro_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b7a51d0c65e32725b45e959086ad73a inherit pro_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a1b7a51d0c65e32725b45e959086ad73a">notifyObservers</a> (<a class="el" href="namespacealexa_client_s_d_k_1_1settings.html#a65b348e86299aa3f3fcdf4a5f924e025">SettingNotifications</a> notification)</td></tr>
<tr class="separator:a1b7a51d0c65e32725b45e959086ad73a inherit pro_methods_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">alexaClientSDK::settings::SettingInterface&lt; ValueT &gt;</a></td></tr>
<tr class="memitem:a4e42d592da8a88af34fbd35902a5cb84 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">std::mutex&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a4e42d592da8a88af34fbd35902a5cb84">m_observerMutex</a></td></tr>
<tr class="memdesc:a4e42d592da8a88af34fbd35902a5cb84 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mutex used to guard observers.  <a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a4e42d592da8a88af34fbd35902a5cb84">More...</a><br /></td></tr>
<tr class="separator:a4e42d592da8a88af34fbd35902a5cb84 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5104c758d4c654e3940692035718b997 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a3157e9ad281e270e4fafa721977645c5">ObserverType</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a5104c758d4c654e3940692035718b997">m_observers</a></td></tr>
<tr class="memdesc:a5104c758d4c654e3940692035718b997 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set of all observers of this setting.  <a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a5104c758d4c654e3940692035718b997">More...</a><br /></td></tr>
<tr class="separator:a5104c758d4c654e3940692035718b997 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0157ca24ccc6f088864ceedcd458bdb4 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memItemLeft" align="right" valign="top">std::conditional&lt; std::is_scalar&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a> &gt;::value, std::atomic&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a> &gt;, <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad2e51acb29ec4de6cfca094e5e871a1c">GuardedValue</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a0157ca24ccc6f088864ceedcd458bdb4">m_value</a></td></tr>
<tr class="memdesc:a0157ca24ccc6f088864ceedcd458bdb4 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">The setting value. (is_trivially_copyble is not supported on gcc4.8)  <a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a0157ca24ccc6f088864ceedcd458bdb4">More...</a><br /></td></tr>
<tr class="separator:a0157ca24ccc6f088864ceedcd458bdb4 inherit pro_attribs_classalexa_client_s_d_k_1_1settings_1_1_setting_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename ValueT&gt;<br />
class alexaClientSDK::settings::Setting&lt; ValueT &gt;</h3>

<p class="">The setting class implements the setting interface for the given value.</p>
<p class="">This class provide methods to set value through local request (<code>set</code> method) and through AVS request (<code>setAvsChange</code>). This setting should also be able to persist the current value as well as revert to previous value if a transaction fails.</p>
<p class="">The setting can be configured to use multiple avs synchronization protocols. See <code><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_protocol_interface.html">SettingProtocolInterface</a></code>.</p>
<dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">ValueT</td><td>The type of the value used to represent a given setting. </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a61935305c6fe45ec6b9f7ec29a2a8842"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a61935305c6fe45ec6b9f7ec29a2a8842">&#9670;&nbsp;</a></span>ValueType</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ValueT &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">alexaClientSDK::settings::Setting</a>&lt; ValueT &gt;::<a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> =  ValueT</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Define an alias for setting value type. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae6762ec41c5f95eb9d70de9f77c7bbfd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae6762ec41c5f95eb9d70de9f77c7bbfd">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ValueT &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">Setting</a>&lt; ValueT &gt; &gt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">alexaClientSDK::settings::Setting</a>&lt; ValueT &gt;::create </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;&#160;</td>
          <td class="paramname"><em>defaultValue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_protocol_interface.html">SettingProtocolInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>settingProtocol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::function&lt; bool(const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;)&gt;&#160;</td>
          <td class="paramname"><em>applyValueFn</em> = <code>std::function&lt;bool(const&#160;<a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a>&amp;)&gt;()</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Create a <code><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">Setting</a></code> object.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">defaultValue</td><td>The default value to be used if no value was found in the storage. </td></tr>
    <tr><td class="paramname">settingProtocol</td><td>The avs protocol used to persist and synchronize values with avs. </td></tr>
    <tr><td class="paramname">applyValueFn</td><td>Function responsible for validating and applying a new setting value to the device. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>The <code>applyValueFn</code> should succeed if there is no value change. </dd></dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the new object if it succeeds; <code>nullptr</code> otherwise. </dd></dl>

</div>
</div>
<a id="aa5384b7a6caf7330b59f552c14287610"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5384b7a6caf7330b59f552c14287610">&#9670;&nbsp;</a></span>setAvsChange()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ValueT &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">alexaClientSDK::settings::Setting</a>&lt; ValueT &gt;::setAvsChange </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Request to set the managed setting to the given <code>value</code>. This should be used when the request came from AVS.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>The target value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if it succeeds to enqueue the request;  otherwise. </dd></dl>

</div>
</div>
<a id="afbc4078956e082308e2137df57dd349d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afbc4078956e082308e2137df57dd349d">&#9670;&nbsp;</a></span>setLocalChange()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ValueT &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5">SetSettingResult</a> <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">alexaClientSDK::settings::Setting</a>&lt; ValueT &gt;::setLocalChange </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html#a61935305c6fe45ec6b9f7ec29a2a8842">ValueType</a> &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Request to set the managed setting to the given <code>value</code>. Note that this is an asynchronous operation.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>The target value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The result of the enqueue operation. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a71279bdc081594ac478f5680cbfbf83f">alexaClientSDK::settings::SettingInterface&lt; ValueT &gt;</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/Settings/include/Settings/<a class="el" href="_setting_8h_source.html">Setting.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
